<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/AccessoryGroup.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('AccessoryGroup_8cpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">AccessoryGroup.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">project: &lt;Accessories&gt;</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">author: &lt;Thierry PARIS&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">description: &lt;Class for a group of accessories&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">*************************************************************/</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Accessories_8h.html">Accessories.h</a>&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;EEPROM.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#ifndef NO_GROUP</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;ActionsStack.hpp&quot;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#ifdef VISUALSTUDIO</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include&lt;stdarg.h&gt;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#define CHECKINDEX(val, text)   CheckIndex(val, F(text))</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#define CHECKINDEXITEM(val, text)   CheckIndex(val, F(text))</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#define CHECKINDEX(val, text)</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#define CHECKINDEXITEM(val, text)</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment">/***********************************************************</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment">*       GroupStateItem</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment">************************************************************/</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_PRINT_ACCESSORIES</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keywordtype">void</span> GroupStateItem::printAccessory()</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;{</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;             Acc : ID &quot;</span>));</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    Serial.print(this-&gt;pAccessory-&gt;<a class="code" href="classAccessory.html#a4f0410f39fa692494b51bc880714bdd1">GetMovingPositionIdByIndex</a>(0));</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    Serial.print(F(<span class="stringliteral">&quot; / State &quot;</span>));</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    Serial.print(this-&gt;State);</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    Serial.print(F(<span class="stringliteral">&quot; / AssyncDelay &quot;</span>));</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    Serial.println(this-&gt;Delay);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;}</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment">/***********************************************************</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment">*       GroupState</span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment">************************************************************/</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="classGroupState.html#a6e52f8db6a65174dc33d69358437bfac">   47</a></span>&#160;<a class="code" href="classGroupState.html#abd63266166b098086d0ccebf98b0e269">GroupState::GroupState</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <span class="keywordtype">bool</span> inSynchrone)</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;{</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    this-&gt;Id = inId;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    this-&gt;Synchronous = inSynchrone;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#a8048782bdfd21cd416e50149973a952f">HasCurrentNull</a> = <span class="keyword">true</span>;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;}</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="classGroupState.html#a97d7335581b8417e3a4ebf7632d6292c">   54</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classGroupState.html#a97d7335581b8417e3a4ebf7632d6292c">GroupState::begin</a>()</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;{</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;   GroupState begin&quot;</span>));</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;}</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="comment">/*void GroupState::begin(GroupStateItem *inpFirstItem, ...)</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="comment">{</span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="comment">    va_list argList;</span></div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="comment">    this-&gt;Items.AddItem(*inpFirstItem);</span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="comment">    va_start(argList, inpFirstItem);</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="comment">    GroupStateItem *item = NULL;</span></div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="comment">    do {</span></div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="comment">        if (item != NULL)</span></div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="comment">            this-&gt;Items.AddItem(*item);</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment">        item = va_arg(argList, GroupStateItem *);</span></div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment">    } while (item != NULL);</span></div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment">    va_end(argList);</span></div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment">} */</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="classGroupState.html#a5d3809e4d9e2bcf71f64a32e4152ebb4">   76</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classGroupState.html#a5d3809e4d9e2bcf71f64a32e4152ebb4">GroupState::Add</a>(<a class="code" href="classAccessory.html">Accessory</a> *inpAccessory, ACC_STATE inState, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> inDelay)</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;{ </div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#a57717781c95414794910f53b0500ea3d">AddItem</a>(<span class="keyword">new</span> <a class="code" href="classGroupStateItem.html">GroupStateItem</a>(inpAccessory, inState, inDelay)); </div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;}</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="classGroupState.html#acf65dca9f5cb8a4ef1f1a07ab0a888b2">   81</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classGroupState.html#acf65dca9f5cb8a4ef1f1a07ab0a888b2">GroupState::StartAction</a>()</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;{</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classGroupState.html#a447de3adf2c1d8e069d1e6480dec9956">IsActionItemPending</a>())</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    {</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#ac7147ad27413bf0439855df743886053">ResetCurrent</a>();</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    }</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    this-&gt;startActionTime = 0;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keywordflow">if</span> (this-&gt;Synchronous)</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    {</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <a class="code" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt;GroupStateItem&gt;</a> *pCurr = this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#a023941d1bf9661dd5f939575eb946bb2">pFirst</a>;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        {</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;            pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;pAccessory-&gt;<a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">StartAction</a>(pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;State);</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            pCurr = pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a84d1cb369351e06476c50df50914f63f">pNext</a>;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        }</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#ac7147ad27413bf0439855df743886053">ResetCurrent</a>();</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    }</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#ad621d76251ac543fc892420f98d704ba">StartCurrent</a>();</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keywordflow">if</span> (this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a>-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;Delay != 0)</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        this-&gt;startActionTime = millis();</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a>-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;pAccessory-&gt;<a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">StartAction</a>(this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a>-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;State);</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;}</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="classGroupState.html#aff83f7f1ac81f36355ead09c92ea093c">  112</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classGroupState.html#aff83f7f1ac81f36355ead09c92ea093c">GroupState::loop</a>()</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;{</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classGroupState.html#a447de3adf2c1d8e069d1e6480dec9956">IsActionItemPending</a>())</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordflow">if</span> (this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a>-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;pAccessory-&gt;<a class="code" href="classAccessory.html#aef81e617d15f62090ccce7eee4f0d3c3">IsGroupActionPending</a>())</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keywordflow">if</span> (this-&gt;startActionTime != 0)</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="keywordflow">if</span> (millis() - this-&gt;startActionTime &lt; this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a>-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;Delay)</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;            <span class="keywordflow">return</span>;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;AccessoryGroupState next action state accessory &quot;</span>));</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#a5b7ce14101b3e2bb6c6ed1a515a8ba93">NextCurrent</a>();</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="keywordflow">if</span> (this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#aec3d93b7e6c96031af848629d72905bd">HasCurrent</a>())</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a>-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;pAccessory-&gt;<a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">StartAction</a>(this-&gt;Items.pCurrentItem-&gt;Obj-&gt;State);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;}</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_PRINT_ACCESSORIES</span></div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="keywordtype">void</span> GroupState::printAccessory()</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;{</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;        State : ID &quot;</span>));</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    Serial.println(this-&gt;Id);</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <a class="code" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt;GroupStateItem&gt;</a> *pCurr = this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#a023941d1bf9661dd5f939575eb946bb2">pFirst</a>;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    {</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;printAccessory();</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a84d1cb369351e06476c50df50914f63f">pNext</a>;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    }</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;}</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="comment">/***********************************************************</span></div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="comment">*       AccessoryGroup</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;<span class="comment">************************************************************/</span></div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *AccessoryGroup::pFirstGroup = NULL;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;AccessoryGroup::AccessoryGroup()</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;{</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a8048782bdfd21cd416e50149973a952f">HasCurrentNull</a> = <span class="keyword">true</span>;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    this-&gt;pNextGroup = NULL;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    AddGroup(<span class="keyword">this</span>);</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;}</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#a1ba534d4bee2acdb03fa9fbd94d4c871">  164</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#a1ba534d4bee2acdb03fa9fbd94d4c871">AccessoryGroup::begin</a>()</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;{</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;   AccessoryGroup begin&quot;</span>));</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;}</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;</div><div class="line"><a name="l00171"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#a0c773ab063b3d8dc175a4fdd4bc37dbf">  171</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#a0c773ab063b3d8dc175a4fdd4bc37dbf">AccessoryGroup::AddStateItem</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <a class="code" href="classAccessory.html">Accessory</a> &amp;inAccessory, ACC_STATE inState, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> inDelay)</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;{</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <a class="code" href="classGroupState.html">GroupState</a> *pState = this-&gt;<a class="code" href="classAccessoryGroup.html#a44a43ba4687d9cd3863ec9d1f9a55cde">GetByID</a>(inId);</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    <span class="keywordflow">if</span> (pState == NULL)</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    {</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;   AccessoryGroup wrong state id !&quot;</span>));</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    }</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    pState-&gt;<a class="code" href="classGroupState.html#a5d3809e4d9e2bcf71f64a32e4152ebb4">Add</a>(&amp;inAccessory, inState, inDelay);</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;}</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;<span class="keywordtype">void</span> AccessoryGroup::AddGroup(<a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *inGroup)</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;{</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    <span class="keywordflow">if</span> (AccessoryGroup::pFirstGroup == NULL)</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    {</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        AccessoryGroup::pFirstGroup = inGroup;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        inGroup-&gt;SetNextGroup(NULL);</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    }</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *pCurr = AccessoryGroup::pFirstGroup;</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    <span class="keywordflow">while</span> (pCurr-&gt;GetNextGroup() != NULL)</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        pCurr = pCurr-&gt;GetNextGroup();</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    pCurr-&gt;SetNextGroup(inGroup);</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    inGroup-&gt;SetNextGroup(NULL);</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;}</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div><div class="line"><a name="l00204"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#ae8a5619af703b0bab9b8fe7236e057d0">  204</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#ae8a5619af703b0bab9b8fe7236e057d0">AccessoryGroup::AddRange</a>(<span class="keyword">const</span> <a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> &amp;inGroup)</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;{</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <a class="code" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt;GroupState&gt;</a> *pCurr = inGroup.States.<a class="code" href="classACCSCHAINEDLIST.html#a023941d1bf9661dd5f939575eb946bb2">pFirst</a>;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    {</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a57717781c95414794910f53b0500ea3d">AddItem</a>(pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>);</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a84d1cb369351e06476c50df50914f63f">pNext</a>;</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    }</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;}</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;</div><div class="line"><a name="l00215"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#a5c852b40b4303445aaf77bfd03095b1f">  215</a></span>&#160;uint8_t <a class="code" href="classAccessoryGroup.html#a5c852b40b4303445aaf77bfd03095b1f">AccessoryGroup::GetCount</a>()</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;{</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    uint8_t count = 0;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    <a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *pCurr = AccessoryGroup::pFirstGroup;</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    {</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        count++;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        pCurr = pCurr-&gt;GetNextGroup();</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    }</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;    <span class="keywordflow">return</span> count;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;}</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div><div class="line"><a name="l00228"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#a44a43ba4687d9cd3863ec9d1f9a55cde">  228</a></span>&#160;<a class="code" href="classGroupState.html">GroupState</a> *<a class="code" href="classAccessoryGroup.html#a44a43ba4687d9cd3863ec9d1f9a55cde">AccessoryGroup::GetByID</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId)<span class="keyword"> const</span></div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;<span class="keyword"></span>{</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <a class="code" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt;GroupState&gt;</a> *pItem = this-&gt;<a class="code" href="classAccessoryGroup.html#ab6ba5894c5a5fc03e1be8db5a0cd4a90">GetItemByID</a>(inId);</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    <span class="keywordflow">if</span> (pItem == NULL)</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        <span class="keywordflow">return</span> NULL;</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    <span class="keywordflow">return</span> pItem-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>;</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;}</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;</div><div class="line"><a name="l00238"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#ab6ba5894c5a5fc03e1be8db5a0cd4a90">  238</a></span>&#160;<a class="code" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt;GroupState&gt;</a> *<a class="code" href="classAccessoryGroup.html#ab6ba5894c5a5fc03e1be8db5a0cd4a90">AccessoryGroup::GetItemByID</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId)<span class="keyword"> const</span></div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;<span class="keyword"></span>{</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    <a class="code" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt;GroupState&gt;</a> *pCurr = this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a023941d1bf9661dd5f939575eb946bb2">pFirst</a>;</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    {</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        <span class="keywordflow">if</span> (pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;GetId() == inId)</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;            <span class="keywordflow">return</span> pCurr;</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a84d1cb369351e06476c50df50914f63f">pNext</a>;</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    }</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    <span class="keywordflow">return</span> NULL;</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;}</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;</div><div class="line"><a name="l00252"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#a47a16211e59138801c734a445867d137">  252</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classAccessoryGroup.html#a47a16211e59138801c734a445867d137">AccessoryGroup::IsActionItemPending</a>()</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;{</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;    <span class="keywordflow">return</span> (this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#aec3d93b7e6c96031af848629d72905bd">HasCurrent</a>());</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;}</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;</div><div class="line"><a name="l00257"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#aa7161fb1c8e33b10008cd70e373bdff2">  257</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#aa7161fb1c8e33b10008cd70e373bdff2">AccessoryGroup::StartAction</a>(<a class="code" href="classGroupState.html">GroupState</a> *inpState)</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;{</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;AccessoryGroup start action state &quot;</span>));</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    Serial.println(inpState-&gt;<a class="code" href="classGroupState.html#a8500c1d72dacb2c210cb243ab6ad849d">GetId</a>());</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    <a class="code" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt;GroupState&gt;</a> *pCurr = this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a023941d1bf9661dd5f939575eb946bb2">pFirst</a>;</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    {</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        <span class="keywordflow">if</span> (pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a> == inpState)</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        {</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;            this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a> = pCurr;</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;            Accessories::EEPROMSave();</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;            pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;StartAction();</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;            <span class="keywordflow">return</span>;</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        }</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a84d1cb369351e06476c50df50914f63f">pNext</a>;</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    }</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;}</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;</div><div class="line"><a name="l00281"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#af218475c80604838386e6a1ae342f88c">  281</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classAccessoryGroup.html#af218475c80604838386e6a1ae342f88c">AccessoryGroup::loop</a>()</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;{</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classAccessoryGroup.html#a47a16211e59138801c734a445867d137">IsActionItemPending</a>())</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;   <span class="comment">// nothing done !</span></div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;    this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a>-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;<a class="code" href="classGroupState.html#aff83f7f1ac81f36355ead09c92ea093c">loop</a>();</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    <span class="keywordflow">if</span> (!this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a>-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;<a class="code" href="classGroupState.html#a447de3adf2c1d8e069d1e6480dec9956">IsActionItemPending</a>())</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#ac7147ad27413bf0439855df743886053">ResetCurrent</a>();</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;}</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;<span class="keyword">static</span> <a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *pLoopGroup = NULL;</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;</div><div class="line"><a name="l00294"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#a4e51991ec66066df63057550b79febd9">  294</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classAccessoryGroup.html#a4e51991ec66066df63057550b79febd9">AccessoryGroup::loops</a>()</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;{</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;    <span class="keywordflow">if</span> (pLoopGroup == NULL)</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    {</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        pLoopGroup = AccessoryGroup::pFirstGroup;</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    }</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;    {</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        <span class="keywordflow">if</span> (pLoopGroup-&gt;GetNextGroup() == NULL)</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;            pLoopGroup = AccessoryGroup::pFirstGroup;</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;        <span class="keywordflow">else</span></div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;            pLoopGroup = pLoopGroup-&gt;GetNextGroup();</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;    }</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    <span class="keywordflow">if</span> (pLoopGroup == NULL)</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    <span class="keywordflow">return</span> pLoopGroup-&gt;<a class="code" href="classAccessoryGroup.html#af218475c80604838386e6a1ae342f88c">loop</a>();</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;}</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;</div><div class="line"><a name="l00314"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#ab9322f8e1511e5545bbd4bee7077291d">  314</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#ab9322f8e1511e5545bbd4bee7077291d">AccessoryGroup::EventAll</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, ACCESSORIES_EVENT_TYPE inEvent, <span class="keywordtype">int</span> inData)</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;{</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;    <a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *pCurr = AccessoryGroup::pFirstGroup;</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;    {</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        <a class="code" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt;GroupState&gt;</a> *pCurrState = pCurr-&gt;States.pFirst;</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;        <span class="keywordflow">while</span> (pCurrState != NULL)</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;        {</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;            <span class="keywordflow">if</span> (pCurrState-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;<a class="code" href="classGroupState.html#a8500c1d72dacb2c210cb243ab6ad849d">GetId</a>() == inId)</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;                <span class="keywordflow">break</span>;</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;            pCurrState = pCurrState-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a84d1cb369351e06476c50df50914f63f">pNext</a>;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;        }</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;        <span class="keywordflow">if</span> (pCurrState != NULL)</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;        pCurr = pCurr-&gt;GetNextGroup();</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;    }</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;    <span class="keywordflow">if</span> (pCurr != NULL)</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;        pCurr-&gt;Event(inId, inEvent, inData);</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;}</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;</div><div class="line"><a name="l00339"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#aa8b6473e417837efbe8dfd8c0221a6a0">  339</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#aa8b6473e417837efbe8dfd8c0221a6a0">AccessoryGroup::Event</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, ACCESSORIES_EVENT_TYPE inEvent, <span class="keywordtype">int</span> inData)</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;{</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;    this-&gt;<a class="code" href="classAccessoryGroup.html#af48bad3fa19a9aa30a39c827b57140e4">Toggle</a>(inId);</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;}</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;</div><div class="line"><a name="l00344"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#af48bad3fa19a9aa30a39c827b57140e4">  344</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classAccessoryGroup.html#af48bad3fa19a9aa30a39c827b57140e4">AccessoryGroup::Toggle</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId)</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;{</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    <a class="code" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt;GroupState&gt;</a> *pCurr = this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a023941d1bf9661dd5f939575eb946bb2">pFirst</a>;</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;    {</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;        <span class="keywordflow">if</span> (pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;GetId() == inId)</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a84d1cb369351e06476c50df50914f63f">pNext</a>;</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    }</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;    <span class="keywordflow">if</span> (pCurr == NULL)</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;    <span class="keywordflow">if</span> (<a class="code" href="classActionsStack.html#aef1d9742f23cad44c4e85e0cfdf942e9">ActionsStack::FillingStack</a>)</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;    {</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;        <a class="code" href="classActionsStack.html#a458994617bfbd0f8aee0fb93abcdb347">ActionsStack::Actions</a>.<a class="code" href="classActionsStack.html#a12c3702836732893421ef6a75c504eda">Add</a>(inId, ACCESSORIES_EVENT_MOVEPOSITIONID);</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;    }</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;AccessoryGroup moved &quot;</span>));</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;    Serial.println(inId);</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;    <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classAccessoryGroup.html#a47a16211e59138801c734a445867d137">IsActionItemPending</a>())</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;    {</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;No action item pending...&quot;</span>));</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;        this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a> = pCurr;</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;        Accessories::EEPROMSave();</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;        pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;StartAction();</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;    }</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;}</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;<span class="keywordtype">int</span> <a class="code" href="classAccessoryGroup.html#aa872b142ab9d2c35a6b7db675e2d480a">AccessoryGroup::EEPROMSave</a>(<span class="keywordtype">int</span> inPos, <span class="keywordtype">bool</span> inSimulate)</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;{</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;    <span class="keywordflow">if</span> (!inSimulate)</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;    {</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;        <span class="keywordflow">if</span> (this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a> != NULL)</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;        {</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">id</span> = this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a>-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;<a class="code" href="classGroupState.html#a8500c1d72dacb2c210cb243ab6ad849d">GetId</a>();</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;            byte *pEvent = (byte *)&amp;<span class="keywordtype">id</span>;</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;            EEPROM.write(inPos, *pEvent);</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;            EEPROM.write(inPos+1, *(pEvent + 1));</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;            EEPROM.write(inPos+2, *(pEvent + 2));</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;            EEPROM.write(inPos+3, *(pEvent + 3));</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;        }</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;        <span class="keywordflow">else</span></div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;        {</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;            EEPROM.write(inPos, 0);</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;            EEPROM.write(inPos+1, 0);</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;            EEPROM.write(inPos+2, 0);</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;            EEPROM.write(inPos+3, 0);</div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;        }</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;    }</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;    inPos += <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> long);</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;    <span class="keywordflow">return</span> inPos;</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;}</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;<span class="keywordtype">int</span> <a class="code" href="classAccessoryGroup.html#a7a552fc64261c5c812ce152ee80ab291">AccessoryGroup::EEPROMLoad</a>(<span class="keywordtype">int</span> inPos)</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;{</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;    <span class="keywordtype">long</span> four = EEPROM.read(inPos++);</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;    <span class="keywordtype">long</span> three = EEPROM.read(inPos++);</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;    <span class="keywordtype">long</span> two = EEPROM.read(inPos++);</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;    <span class="keywordtype">long</span> one = EEPROM.read(inPos++);</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;    <span class="keywordflow">if</span> (one+two+three+four &gt; 0)</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;    {</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;        <span class="comment">//Rebuild the recomposed long by using bitshift.</span></div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> ID = ((four &lt;&lt; 0) &amp; 0xFF) + ((three &lt;&lt; 8) &amp; 0xFFFF) + ((two &lt;&lt; 16) &amp; 0xFFFFFF) + ((one &lt;&lt; 24) &amp; 0xFFFFFFFF);</div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;        <a class="code" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt;GroupState&gt;</a> *grp = <a class="code" href="classAccessoryGroup.html#ab6ba5894c5a5fc03e1be8db5a0cd4a90">AccessoryGroup::GetItemByID</a>(ID);</div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;        this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a> = grp;</div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;    }</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;    {</div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;        this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a> = NULL;</div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;    }</div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;</div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;    <span class="keywordflow">return</span> inPos;</div><div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;}</div><div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;</div><div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;<span class="keywordtype">int</span> <a class="code" href="classAccessoryGroup.html#a414d80944dab2b6ee852fac72e2139d7">AccessoryGroup::EEPROMSaveAll</a>(<span class="keywordtype">int</span> inPos, <span class="keywordtype">bool</span> inSimulate)</div><div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;{</div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;    <a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *pCurr = pFirstGroup;</div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;</div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;    {</div><div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;        inPos = pCurr-&gt;EEPROMSave(inPos, inSimulate);</div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;        pCurr = pCurr-&gt;pNextGroup;</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;    }</div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;</div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;    <span class="keywordflow">return</span> inPos;</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;}</div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;</div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;<span class="keywordtype">int</span> <a class="code" href="classAccessoryGroup.html#a0dac6d80624d22f75d7e5612f2ac34cf">AccessoryGroup::EEPROMLoadAll</a>(<span class="keywordtype">int</span> inPos)</div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;{</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;    <a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *pCurr = pFirstGroup;</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;    {</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;        inPos = pCurr-&gt;EEPROMLoad(inPos);</div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;        pCurr = pCurr-&gt;pNextGroup;</div><div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;    }</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;    <span class="keywordflow">return</span> inPos;</div><div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;}</div><div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_PRINT_ACCESSORIES</span></div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;<span class="keywordtype">void</span> AccessoryGroup::printGroups()</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;{</div><div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;    <a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *pCurr = pFirstGroup;</div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;</div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;    {</div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;        pCurr-&gt;printAccessory();</div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;        pCurr = pCurr-&gt;pNextGroup;</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;    }</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;}</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;</div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;<span class="keywordtype">void</span> AccessoryGroup::printAccessory()</div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;{</div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;    Group : &quot;</span>));</div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;</div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;    <a class="code" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt;GroupState&gt;</a> *pCurr = this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a023941d1bf9661dd5f939575eb946bb2">pFirst</a>;</div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;</div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;    {</div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;        pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">Obj</a>-&gt;printAccessory();</div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classACCSCHAINEDLISTITEM.html#a84d1cb369351e06476c50df50914f63f">pNext</a>;</div><div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;    }</div><div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;}</div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classAccessoryGroup_html_a0dac6d80624d22f75d7e5612f2ac34cf"><div class="ttname"><a href="classAccessoryGroup.html#a0dac6d80624d22f75d7e5612f2ac34cf">AccessoryGroup::EEPROMLoadAll</a></div><div class="ttdeci">static int EEPROMLoadAll(int inPos)</div></div>
<div class="ttc" id="classAccessoryGroup_html_a414d80944dab2b6ee852fac72e2139d7"><div class="ttname"><a href="classAccessoryGroup.html#a414d80944dab2b6ee852fac72e2139d7">AccessoryGroup::EEPROMSaveAll</a></div><div class="ttdeci">static int EEPROMSaveAll(int inPos, bool inSimulate = false)</div></div>
<div class="ttc" id="classAccessoryGroup_html_aa872b142ab9d2c35a6b7db675e2d480a"><div class="ttname"><a href="classAccessoryGroup.html#aa872b142ab9d2c35a6b7db675e2d480a">AccessoryGroup::EEPROMSave</a></div><div class="ttdeci">int EEPROMSave(int inPos, bool inSimulate = false)</div></div>
<div class="ttc" id="classActionsStack_html_a12c3702836732893421ef6a75c504eda"><div class="ttname"><a href="classActionsStack.html#a12c3702836732893421ef6a75c504eda">ActionsStack::Add</a></div><div class="ttdeci">unsigned char Add(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="ActionsStack_8cpp_source.html#l00031">ActionsStack.cpp:31</a></div></div>
<div class="ttc" id="classActionsStack_html_a458994617bfbd0f8aee0fb93abcdb347"><div class="ttname"><a href="classActionsStack.html#a458994617bfbd0f8aee0fb93abcdb347">ActionsStack::Actions</a></div><div class="ttdeci">static ActionsStack Actions</div><div class="ttdef"><b>Definition:</b> <a href="ActionsStack_8hpp_source.html#l00069">ActionsStack.hpp:69</a></div></div>
<div class="ttc" id="classActionsStack_html_aef1d9742f23cad44c4e85e0cfdf942e9"><div class="ttname"><a href="classActionsStack.html#aef1d9742f23cad44c4e85e0cfdf942e9">ActionsStack::FillingStack</a></div><div class="ttdeci">static bool FillingStack</div><div class="ttdef"><b>Definition:</b> <a href="ActionsStack_8hpp_source.html#l00071">ActionsStack.hpp:71</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_af48bad3fa19a9aa30a39c827b57140e4"><div class="ttname"><a href="classAccessoryGroup.html#af48bad3fa19a9aa30a39c827b57140e4">AccessoryGroup::Toggle</a></div><div class="ttdeci">bool Toggle(unsigned long inId)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00344">AccessoryGroup.cpp:344</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a4e51991ec66066df63057550b79febd9"><div class="ttname"><a href="classAccessoryGroup.html#a4e51991ec66066df63057550b79febd9">AccessoryGroup::loops</a></div><div class="ttdeci">static bool loops()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00294">AccessoryGroup.cpp:294</a></div></div>
<div class="ttc" id="classGroupState_html_a8500c1d72dacb2c210cb243ab6ad849d"><div class="ttname"><a href="classGroupState.html#a8500c1d72dacb2c210cb243ab6ad849d">GroupState::GetId</a></div><div class="ttdeci">unsigned long GetId() const </div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00095">AccessoryGroup.hpp:95</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a47a16211e59138801c734a445867d137"><div class="ttname"><a href="classAccessoryGroup.html#a47a16211e59138801c734a445867d137">AccessoryGroup::IsActionItemPending</a></div><div class="ttdeci">bool IsActionItemPending()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00252">AccessoryGroup.cpp:252</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_ab6ba5894c5a5fc03e1be8db5a0cd4a90"><div class="ttname"><a href="classAccessoryGroup.html#ab6ba5894c5a5fc03e1be8db5a0cd4a90">AccessoryGroup::GetItemByID</a></div><div class="ttdeci">ACCSCHAINEDLISTITEM&lt; GroupState &gt; * GetItemByID(unsigned long inId) const </div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00238">AccessoryGroup.cpp:238</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a5c852b40b4303445aaf77bfd03095b1f"><div class="ttname"><a href="classAccessoryGroup.html#a5c852b40b4303445aaf77bfd03095b1f">AccessoryGroup::GetCount</a></div><div class="ttdeci">static uint8_t GetCount()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00215">AccessoryGroup.cpp:215</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_ae8a5619af703b0bab9b8fe7236e057d0"><div class="ttname"><a href="classAccessoryGroup.html#ae8a5619af703b0bab9b8fe7236e057d0">AccessoryGroup::AddRange</a></div><div class="ttdeci">void AddRange(const AccessoryGroup &amp;inGroup)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00204">AccessoryGroup.cpp:204</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a44a43ba4687d9cd3863ec9d1f9a55cde"><div class="ttname"><a href="classAccessoryGroup.html#a44a43ba4687d9cd3863ec9d1f9a55cde">AccessoryGroup::GetByID</a></div><div class="ttdeci">GroupState * GetByID(unsigned long inId) const </div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00228">AccessoryGroup.cpp:228</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a0c773ab063b3d8dc175a4fdd4bc37dbf"><div class="ttname"><a href="classAccessoryGroup.html#a0c773ab063b3d8dc175a4fdd4bc37dbf">AccessoryGroup::AddStateItem</a></div><div class="ttdeci">void AddStateItem(unsigned long inId, Accessory &amp;inAccessory, ACC_STATE inState, unsigned int inDelay = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00171">AccessoryGroup.cpp:171</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a1ba534d4bee2acdb03fa9fbd94d4c871"><div class="ttname"><a href="classAccessoryGroup.html#a1ba534d4bee2acdb03fa9fbd94d4c871">AccessoryGroup::begin</a></div><div class="ttdeci">void begin()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00164">AccessoryGroup.cpp:164</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_aa7161fb1c8e33b10008cd70e373bdff2"><div class="ttname"><a href="classAccessoryGroup.html#aa7161fb1c8e33b10008cd70e373bdff2">AccessoryGroup::StartAction</a></div><div class="ttdeci">void StartAction(GroupState *inpState)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00257">AccessoryGroup.cpp:257</a></div></div>
<div class="ttc" id="classAccessoryGroup_html"><div class="ttname"><a href="classAccessoryGroup.html">AccessoryGroup</a></div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00120">AccessoryGroup.hpp:120</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_aa8b6473e417837efbe8dfd8c0221a6a0"><div class="ttname"><a href="classAccessoryGroup.html#aa8b6473e417837efbe8dfd8c0221a6a0">AccessoryGroup::Event</a></div><div class="ttdeci">void Event(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00339">AccessoryGroup.cpp:339</a></div></div>
<div class="ttc" id="classACCSCHAINEDLIST_html_aec3d93b7e6c96031af848629d72905bd"><div class="ttname"><a href="classACCSCHAINEDLIST.html#aec3d93b7e6c96031af848629d72905bd">ACCSCHAINEDLIST::HasCurrent</a></div><div class="ttdeci">bool HasCurrent()</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00059">Chain.hpp:59</a></div></div>
<div class="ttc" id="classACCSCHAINEDLIST_html_a5b7ce14101b3e2bb6c6ed1a515a8ba93"><div class="ttname"><a href="classACCSCHAINEDLIST.html#a5b7ce14101b3e2bb6c6ed1a515a8ba93">ACCSCHAINEDLIST::NextCurrent</a></div><div class="ttdeci">void NextCurrent()</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00099">Chain.hpp:99</a></div></div>
<div class="ttc" id="classAccessory_html_aef81e617d15f62090ccce7eee4f0d3c3"><div class="ttname"><a href="classAccessory.html#aef81e617d15f62090ccce7eee4f0d3c3">Accessory::IsGroupActionPending</a></div><div class="ttdeci">virtual bool IsGroupActionPending() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00404">Accessory.hpp:404</a></div></div>
<div class="ttc" id="classGroupState_html_aff83f7f1ac81f36355ead09c92ea093c"><div class="ttname"><a href="classGroupState.html#aff83f7f1ac81f36355ead09c92ea093c">GroupState::loop</a></div><div class="ttdeci">void loop()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00112">AccessoryGroup.cpp:112</a></div></div>
<div class="ttc" id="classACCSCHAINEDLIST_html_a154d3c5354d97450a9184551691661cc"><div class="ttname"><a href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">ACCSCHAINEDLIST::pCurrentItem</a></div><div class="ttdeci">ACCSCHAINEDLISTITEM&lt; T &gt; * pCurrentItem</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00039">Chain.hpp:39</a></div></div>
<div class="ttc" id="classACCSCHAINEDLIST_html_ad621d76251ac543fc892420f98d704ba"><div class="ttname"><a href="classACCSCHAINEDLIST.html#ad621d76251ac543fc892420f98d704ba">ACCSCHAINEDLIST::StartCurrent</a></div><div class="ttdeci">void StartCurrent()</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00055">Chain.hpp:55</a></div></div>
<div class="ttc" id="classAccessory_html_ab1dad31ee3bcac4b1baf9a140c7fa57d"><div class="ttname"><a href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">Accessory::StartAction</a></div><div class="ttdeci">virtual void StartAction()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00077">Accessory.cpp:77</a></div></div>
<div class="ttc" id="classACCSCHAINEDLISTITEM_html_a84d1cb369351e06476c50df50914f63f"><div class="ttname"><a href="classACCSCHAINEDLISTITEM.html#a84d1cb369351e06476c50df50914f63f">ACCSCHAINEDLISTITEM::pNext</a></div><div class="ttdeci">ACCSCHAINEDLISTITEM * pNext</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00013">Chain.hpp:13</a></div></div>
<div class="ttc" id="classACCSCHAINEDLISTITEM_html_a950beb6165d1621a8a1d3d3f95a33bb3"><div class="ttname"><a href="classACCSCHAINEDLISTITEM.html#a950beb6165d1621a8a1d3d3f95a33bb3">ACCSCHAINEDLISTITEM::Obj</a></div><div class="ttdeci">T * Obj</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00011">Chain.hpp:11</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_af218475c80604838386e6a1ae342f88c"><div class="ttname"><a href="classAccessoryGroup.html#af218475c80604838386e6a1ae342f88c">AccessoryGroup::loop</a></div><div class="ttdeci">bool loop()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00281">AccessoryGroup.cpp:281</a></div></div>
<div class="ttc" id="classACCSCHAINEDLIST_html_a023941d1bf9661dd5f939575eb946bb2"><div class="ttname"><a href="classACCSCHAINEDLIST.html#a023941d1bf9661dd5f939575eb946bb2">ACCSCHAINEDLIST::pFirst</a></div><div class="ttdeci">ACCSCHAINEDLISTITEM&lt; T &gt; * pFirst</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00037">Chain.hpp:37</a></div></div>
<div class="ttc" id="classACCSCHAINEDLISTITEM_html"><div class="ttname"><a href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt; GroupStateItem &gt;</a></div></div>
<div class="ttc" id="classACCSCHAINEDLIST_html_ac7147ad27413bf0439855df743886053"><div class="ttname"><a href="classACCSCHAINEDLIST.html#ac7147ad27413bf0439855df743886053">ACCSCHAINEDLIST::ResetCurrent</a></div><div class="ttdeci">void ResetCurrent()</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00053">Chain.hpp:53</a></div></div>
<div class="ttc" id="classGroupState_html_a447de3adf2c1d8e069d1e6480dec9956"><div class="ttname"><a href="classGroupState.html#a447de3adf2c1d8e069d1e6480dec9956">GroupState::IsActionItemPending</a></div><div class="ttdeci">bool IsActionItemPending()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00090">AccessoryGroup.hpp:90</a></div></div>
<div class="ttc" id="classGroupState_html_acf65dca9f5cb8a4ef1f1a07ab0a888b2"><div class="ttname"><a href="classGroupState.html#acf65dca9f5cb8a4ef1f1a07ab0a888b2">GroupState::StartAction</a></div><div class="ttdeci">void StartAction()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00081">AccessoryGroup.cpp:81</a></div></div>
<div class="ttc" id="classGroupStateItem_html"><div class="ttname"><a href="classGroupStateItem.html">GroupStateItem</a></div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00015">AccessoryGroup.hpp:15</a></div></div>
<div class="ttc" id="classACCSCHAINEDLIST_html_a57717781c95414794910f53b0500ea3d"><div class="ttname"><a href="classACCSCHAINEDLIST.html#a57717781c95414794910f53b0500ea3d">ACCSCHAINEDLIST::AddItem</a></div><div class="ttdeci">void AddItem(T *t)</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00071">Chain.hpp:71</a></div></div>
<div class="ttc" id="classAccessory_html"><div class="ttname"><a href="classAccessory.html">Accessory</a></div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00140">Accessory.hpp:140</a></div></div>
<div class="ttc" id="classGroupState_html_a5d3809e4d9e2bcf71f64a32e4152ebb4"><div class="ttname"><a href="classGroupState.html#a5d3809e4d9e2bcf71f64a32e4152ebb4">GroupState::Add</a></div><div class="ttdeci">void Add(Accessory *inpAccessory, ACC_STATE inState, unsigned int inDelay = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00076">AccessoryGroup.cpp:76</a></div></div>
<div class="ttc" id="classGroupState_html_a97d7335581b8417e3a4ebf7632d6292c"><div class="ttname"><a href="classGroupState.html#a97d7335581b8417e3a4ebf7632d6292c">GroupState::begin</a></div><div class="ttdeci">void begin()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00054">AccessoryGroup.cpp:54</a></div></div>
<div class="ttc" id="classACCSCHAINEDLIST_html_a8048782bdfd21cd416e50149973a952f"><div class="ttname"><a href="classACCSCHAINEDLIST.html#a8048782bdfd21cd416e50149973a952f">ACCSCHAINEDLIST::HasCurrentNull</a></div><div class="ttdeci">bool HasCurrentNull</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00041">Chain.hpp:41</a></div></div>
<div class="ttc" id="classGroupState_html_abd63266166b098086d0ccebf98b0e269"><div class="ttname"><a href="classGroupState.html#abd63266166b098086d0ccebf98b0e269">GroupState::GroupState</a></div><div class="ttdeci">GroupState()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00065">AccessoryGroup.hpp:65</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_ab9322f8e1511e5545bbd4bee7077291d"><div class="ttname"><a href="classAccessoryGroup.html#ab9322f8e1511e5545bbd4bee7077291d">AccessoryGroup::EventAll</a></div><div class="ttdeci">static void EventAll(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00314">AccessoryGroup.cpp:314</a></div></div>
<div class="ttc" id="classAccessory_html_a4f0410f39fa692494b51bc880714bdd1"><div class="ttname"><a href="classAccessory.html#a4f0410f39fa692494b51bc880714bdd1">Accessory::GetMovingPositionIdByIndex</a></div><div class="ttdeci">unsigned long GetMovingPositionIdByIndex(int inIndex) const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00313">Accessory.hpp:313</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a7a552fc64261c5c812ce152ee80ab291"><div class="ttname"><a href="classAccessoryGroup.html#a7a552fc64261c5c812ce152ee80ab291">AccessoryGroup::EEPROMLoad</a></div><div class="ttdeci">int EEPROMLoad(int inPos)</div></div>
<div class="ttc" id="classGroupState_html"><div class="ttname"><a href="classGroupState.html">GroupState</a></div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00048">AccessoryGroup.hpp:48</a></div></div>
<div class="ttc" id="Accessories_8h_html"><div class="ttname"><a href="Accessories_8h.html">Accessories.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>AccessoryGroup.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
